---
product: "AG Charts"
title: "Stylers"
description: "Stylers allow customisation of the visual appearance of specific items or series based on the data or other conditions."
framework: javascript
version: "14.2.0"
related:
    - title: "Cross Lines"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-cross-lines/"
    - title: "Legend"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/legend/"
    - title: "Formatters"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/formatters/"
    - title: "Series Bars"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/bars/"
    - title: "Series Fills"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/fills/"
    - title: "Series Labels"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/series-labels/"
    - title: "Series Markers"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/markers/"
    - title: "Style Segments"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/style-segments/"
    - title: "Annotations"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/annotations/"
    - title: "Background Regions"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/background-regions/"
    - title: "Colour Scale"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/colour-scale/"
    - title: "Error Bars"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/error-bars/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Stylers

Stylers allow customisation of the visual appearance of specific items or series based on the data or other conditions.

## Item Stylers

An `itemStyler` is a callback function that is called once for each item within the series, and returns style properties for that item.

To change the style of an entire series based on some condition, use a [Series Styler](https://www.ag-grid.com/charts/archive/14.2.0/javascript/stylers/#series-stylers).

#### Item Styler

```ts
import {
  AgChartOptions,
  AgCharts,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { DataType, data } from "./data";

function lerpColor(t: number, color1: string, color2: string): string {
  const tt = Math.max(0, Math.min(1.5, t)) / 1.5;
  const hexToRgb = (hex: string) => {
    const bigint = parseInt(hex.slice(1), 16);
    return {
      r: (bigint >> 16) & 255,
      g: (bigint >> 8) & 255,
      b: bigint & 255,
    };
  };
  const rgbToHex = (r: number, g: number, b: number) =>
    `#${[r, g, b].map((x) => x.toString(16).padStart(2, "0")).join("")}`;
  const c1 = hexToRgb(color1);
  const c2 = hexToRgb(color2);
  const r = Math.round(c1.r + (c2.r - c1.r) * tt);
  const g = Math.round(c1.g + (c2.g - c1.g) * tt);
  const b = Math.round(c1.b + (c2.b - c1.b) * tt);
  return rgbToHex(r, g, b);
}
ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const options: AgChartOptions<DataType> = {
  data: data,
  title: {
    text: "UK Energy Sources",
  },
  subtitle: {
    text: "Source: Department for Business, Energy & Industrial Strategy",
  },
  series: [
    {
      type: "line",
      xKey: "month",
      yKey: "coal",
      yName: "Coal",
      marker: {
        itemStyler: ({ datum: { coal, nuclear }, fill, size }) => {
          return coal > nuclear ? { fill: "#f44", size: 15 } : { fill, size };
        },
      },
      label: {
        itemStyler: ({ datum: { coal, nuclear } }) => {
          if (coal > nuclear) {
            return { fontSize: 12, border: { stroke: "#f44" }, padding: 2 };
          }
          return { fontSize: 8 };
        },
      },
    },
    {
      type: "line",
      xKey: "month",
      yKey: "nuclear",
      yName: "Nuclear",
    },
    {
      type: "bar",
      xKey: "month",
      yKey: "imported",
      yName: "Imported",
      itemStyler: ({ datum, fill, highlightState }) => {
        return {
          fill:
            datum.month === "Jul"
              ? highlightState === "highlighted-item"
                ? "lime"
                : "#f44"
              : fill,
        };
      },
      label: {
        itemStyler: ({ datum: { month } }) => {
          return { color: month !== "Jul" ? "transparent" : undefined };
        },
      },
    },
  ],
  axes: {
    y: {
      type: "number",
      interval: { step: 0.2 },
      gridLine: {
        enabled: false,
      },
      max: 2,
      label: {
        format: "#{.1f}%",
        fontWeight: 600,
        itemStyler: (params) => {
          return {
            color: lerpColor(params.value, "#00b347", "#cc2900"),
          };
        },
      },
      title: {
        text: "Normalized Percentage Energy",
      },
    },
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Item Styler](https://www.ag-grid.com/charts/archive/14.2.0/typescript/stylers/examples/item-styler/)

In this example:

- If the values in the 'Coal' line series are higher than the 'Nuclear' series, the markers and labels are larger and marked in red.
- The 'Imported' series bar for 'Jul' is red with a lime highlight style.
- The y-axis labels are coloured with a gradient scale.

```js
{
    series: [
        {
            type: 'line',
            //...
            marker: {
                itemStyler: ({ datum: { coal, nuclear }, fill, size }) => {
                    return coal > nuclear ? { fill: '#f44', size: 15 } : { fill, size };
                },
            },
            label: {
                itemStyler: ({ datum: { coal, nuclear } }) => {
                    if (coal > nuclear) {
                        return { fontSize: 12, border: { stroke: '#f44' }, padding: 2 };
                    }
                    return { fontSize: 8 };
                },
            },
        },
        {
            type: 'bar',
            //...
            itemStyler: ({ datum, fill, highlightState }) => {
                return {
                    fill:
                        datum.month === 'Jul'
                            ? highlightState === 'highlighted-item'
                                ? 'lime'
                                : '#f44'
                            : fill,
                };
            },
            label: {
                itemStyler: ({ datum: { month } }) => {
                    return { color: month !== 'Jul' ? 'transparent' : undefined };
                },
            },
        },
    ],
    axes: {
        x: {
            //...
            label: {
                itemStyler: (params) => {
                    return { color: lerpColor(params.value, '#00b347', '#cc2900') };
                },
            },
        },
    },
}
```

### Usage

Item Stylers can be found:

- In the `series` object, for customising primitive properties on the series level.
- Inside nested series property objects, such as `marker`.
- Inside series and axes `label` objects.

Each `itemStyler` receives a `params` object containing:

- Relevant details of the item, such as the `datum`, `seriesId`, and `_Keys`.
- The style properties currently applied to the item.
- The [highlight state](https://www.ag-grid.com/charts/archive/14.2.0/javascript/series-highlighting/#stylers) of the item.
- The [selected and candidate state](https://www.ag-grid.com/charts/archive/14.2.0/javascript/selection/#candidacy) of the item.

It should return an object containing the styles to be applied to the item.

The exact details differ between the different series types and components which implement the `itemStyler` function.

Please use the [Options Reference](https://www.ag-grid.com/charts/archive/14.2.0/options/) to learn more about Item Stylers, the inputs they receive and the attributes that can be customised.

## Series Stylers

A `styler` is a callback function that is called once for each series and returns style properties. These are most often used within [Theme Overrides](https://www.ag-grid.com/charts/archive/14.2.0/javascript/themes/#overrides).

#### Series Styler

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const options: AgCartesianChartOptions = {
  title: { text: "Revenue & Growth vs Benchmark" },
  data: getData(),
  theme: {
    overrides: {
      bar: {
        series: {
          styler: (params) => {
            if (params.yKey.includes("benchmark")) {
              return { fill: "lightgray" };
            }
            return { fill: "#5090DC" };
          },
        },
      },
      line: {
        series: {
          marker: { enabled: false },
          strokeWidth: 4,
          styler: (params) => {
            if (params.yKey.includes("benchmark")) {
              return { stroke: "lightgray" };
            }
            return { stroke: "#5090DC" };
          },
        },
      },
    },
  },
  series: [
    { type: "bar", xKey: "year", yKey: "revenue", yName: "Revenue" },
    {
      type: "bar",
      xKey: "year",
      yKey: "revenue_benchmark",
      yName: "Revenue Benchmark",
    },
    {
      type: "line",
      xKey: "year",
      yKey: "growth",
      yName: "Growth",
      yKeyAxis: "ySecondary",
    },
    {
      type: "line",
      xKey: "year",
      yKey: "growth_benchmark",
      yName: "Growth Benchmark",
      yKeyAxis: "ySecondary",
    },
  ],
  axes: {
    y: {
      type: "number",
      position: "left",
      title: { text: "Revenue (M)" },
      max: 500,
    },
    ySecondary: {
      type: "number",
      position: "right",
      title: { text: "Growth Rate (%)" },
      nice: false,
      max: 0.5,
      min: -0.5,
      label: { formatter: ({ value }) => `${(value * 100).toFixed(0)}%` },
    },
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Series Styler](https://www.ag-grid.com/charts/archive/14.2.0/typescript/stylers/examples/series-styler/)

In this example:

- Any series containing 'benchmark' in its key is coloured gray, and the other series are blue.
- The legend items also reflect this styling.

```js
{
    theme: {
        overrides: {
            bar: {
                series: {
                    styler: (params) => {
                        if (params.yKey.includes('benchmark')) {
                            return { fill: 'lightgray' };
                        }
                        return { fill: '#5090DC' };
                    },
                },
            },
            line: {
                series: {
                    styler: (params) => {
                        if (params.yKey.includes('benchmark')) {
                            return { stroke: 'lightgray' };
                        }
                        return { stroke: '#5090DC' };
                    },
                },
            },
        },
    },
}
```

### Usage

The series level `styler` is called before the more specific `itemStyler`, with the results of the `styler` being passed into the `itemStyler` params.

Each `styler` receives a `params` object containing:

- Relevant details of the series, such as the `seriesId`, and `_Keys`.
- The style properties currently applied to the series.
- The [highlight state](https://www.ag-grid.com/charts/archive/14.2.0/javascript/series-highlighting/#stylers) of the series.
- The [selected and candidate state](https://www.ag-grid.com/charts/archive/14.2.0/javascript/selection/#candidacy) of the series.

It should return an object containing the styles to be applied to the series. Styling of nested property objects other than `marker` must be done with an `itemStyler`.

The exact details differ between the different series types. Please use the [Options Reference](https://www.ag-grid.com/charts/archive/14.2.0/options/) to learn more about Stylers, the inputs they receive and the attributes that can be customised.


Stylers allow customisation of the visual appearance of specific items or series based on the data or other conditions.
Item Stylers Copy Link
An itemStyler is a callback function that is called once for each item within the series, and returns style properties for that item.
To change the style of an entire series based on some condition, use a Series Styler.
import { Component } from "@angular/core";
import { AgCharts } from "ag-charts-angular";
import {
AgChartOptions,
BarSeriesModule,
CategoryAxisModule,
LegendModule,
LineSeriesModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-community";
import { DataType, data } from "./data";
function lerpColor(t: number, color1: string, color2: string): string {
const tt = Math.max(0, Math.min(1.5, t)) / 1.5;
const hexToRgb = (hex: string) => {
const bigint = parseInt(hex.slice(1), 16);
return {
r: (bigint >> 16) & 255,
g: (bigint >> 8) & 255,
b: bigint & 255,
};
};
const rgbToHex = (r: number, g: number, b: number) =>
`#${[r, g, b].map((x) => x.toString(16).padStart(2, "0")).join("")}`;
const c1 = hexToRgb(color1);
const c2 = hexToRgb(color2);
const r = Math.round(c1.r + (c2.r - c1.r) * tt);
const g = Math.round(c1.g + (c2.g - c1.g) * tt);
const b = Math.round(c1.b + (c2.b - c1.b) * tt);
return rgbToHex(r, g, b);
}
ModuleRegistry.registerModules([
BarSeriesModule,
CategoryAxisModule,
LegendModule,
LineSeriesModule,
NumberAxisModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgCharts],
template: `<ag-charts
[options]="options"
></ag-charts>
`,
})
export class AppComponent {
public options;
constructor() {
this.options = {
data: data,
title: {
text: "UK Energy Sources",
},
subtitle: {
text: "Source: Department for Business, Energy & Industrial Strategy",
},
series: [
{
type: "line",
xKey: "month",
yKey: "coal",
yName: "Coal",
marker: {
itemStyler: ({ datum: { coal, nuclear }, fill, size }) => {
return coal > nuclear
? { fill: "#f44", size: 15 }
: { fill, size };
},
},
label: {
itemStyler: ({ datum: { coal, nuclear } }) => {
if (coal > nuclear) {
return { fontSize: 12, border: { stroke: "#f44" }, padding: 2 };
}
return { fontSize: 8 };
},
},
},
{
type: "line",
xKey: "month",
yKey: "nuclear",
yName: "Nuclear",
},
{
type: "bar",
xKey: "month",
yKey: "imported",
yName: "Imported",
itemStyler: ({ datum, fill, highlightState }) => {
return {
fill:
datum.month === "Jul"
? highlightState === "highlighted-item"
? "lime"
: "#f44"
: fill,
};
},
label: {
itemStyler: ({ datum: { month } }) => {
return { color: month !== "Jul" ? "transparent" : undefined };
},
},
},
],
axes: {
y: {
type: "number",
interval: { step: 0.2 },
gridLine: {
enabled: false,
},
max: 2,
label: {
format: "#{.1f}%",
fontWeight: 600,
itemStyler: (params) => {
return {
color: lerpColor(params.value, "#00b347", "#cc2900"),
};
},
},
title: {
text: "Normalized Percentage Energy",
},
},
},
};
}
}
export interface DataType {
month: string;
coal: number;
petroleum: number;
naturalGas: number;
bioenergyWaste: number;
nuclear: number;
windSolarHydro: number;
imported: number;
}
// Source: https://www.gov.uk/government/statistics/total-energy-section-1-energy-trends
export const data: DataType[] = [
{
month: "Jan",
coal: 0.8,
petroleum: 5.6,
naturalGas: 9.4,
bioenergyWaste: 1.6,
nuclear: 1.2,
windSolarHydro: 0.7,
imported: 0.2,
},
{
month: "Feb",
coal: 1.1,
petroleum: 5.6,
naturalGas: 8.8,
bioenergyWaste: 1.6,
nuclear: 1.2,
windSolarHydro: 0.5,
imported: 0.1,
},
{
month: "Mar",
coal: 1.4,
petroleum: 5.4,
naturalGas: 9.0,
bioenergyWaste: 1.6,
nuclear: 1.2,
windSolarHydro: 0.6,
imported: 0.1,
},
{
month: "Apr",
coal: 0.6,
petroleum: 5.9,
naturalGas: 6.3,
bioenergyWaste: 1.3,
nuclear: 1.2,
windSolarHydro: 0.5,
imported: 0.1,
},
{
month: "May",
coal: 0.5,
petroleum: 5.6,
naturalGas: 4.5,
bioenergyWaste: 1.3,
nuclear: 1.2,
windSolarHydro: 0.5,
imported: 0.2,
},
{
month: "Jun",
coal: 0.5,
petroleum: 5.8,
naturalGas: 3.8,
bioenergyWaste: 1.3,
nuclear: 1.2,
windSolarHydro: 0.4,
imported: 0.1,
},
{
month: "Jul",
coal: 0.4,
petroleum: 5.6,
naturalGas: 3.9,
bioenergyWaste: 1.3,
nuclear: 1.2,
windSolarHydro: 0.4,
imported: 0.2,
},
{
month: "Aug",
coal: 0.4,
petroleum: 5.9,
naturalGas: 3.7,
bioenergyWaste: 1.3,
nuclear: 1.3,
windSolarHydro: 0.4,
imported: 0.1,
},
{
month: "Sep",
coal: 0.7,
petroleum: 5.8,
naturalGas: 4.1,
bioenergyWaste: 1.3,
nuclear: 1.2,
windSolarHydro: 0.6,
imported: 0.1,
},
{
month: "Oct",
coal: 0.6,
petroleum: 5.5,
naturalGas: 5.9,
bioenergyWaste: 1.6,
nuclear: 1.0,
windSolarHydro: 0.6,
imported: 0.1,
},
{
month: "Nov",
coal: 1.1,
petroleum: 5.9,
naturalGas: 7.3,
bioenergyWaste: 1.6,
nuclear: 1.0,
windSolarHydro: 0.7,
imported: 0.1,
},
{
month: "Dec",
coal: 0.7,
petroleum: 5.8,
naturalGas: 8.2,
bioenergyWaste: 1.6,
nuclear: 1.1,
windSolarHydro: 0.6,
imported: 0.1,
},
];
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent);
In this example:
- If the values in the 'Coal' line series are higher than the 'Nuclear' series, the markers and labels are larger and marked in red.
- The 'Imported' series bar for 'Jul' is red with a lime highlight style.
- The y-axis labels are coloured with a gradient scale.
{
series: [
{
type: 'line',
//...
marker: {
itemStyler: ({ datum: { coal, nuclear }, fill, size }) => {
return coal > nuclear ? { fill: '#f44', size: 15 } : { fill, size };
},
},
label: {
itemStyler: ({ datum: { coal, nuclear } }) => {
if (coal > nuclear) {
return { fontSize: 12, border: { stroke: '#f44' }, padding: 2 };
}
return { fontSize: 8 };
},
},
},
{
type: 'bar',
//...
itemStyler: ({ datum, fill, highlightState }) => {
return {
fill:
datum.month === 'Jul'
? highlightState === 'highlighted-item'
? 'lime'
: '#f44'
: fill,
};
},
label: {
itemStyler: ({ datum: { month } }) => {
return { color: month !== 'Jul' ? 'transparent' : undefined };
},
},
},
],
axes: {
x: {
//...
label: {
itemStyler: (params) => {
return { color: lerpColor(params.value, '#00b347', '#cc2900') };
},
},
},
},
} Usage Copy Link
Item Stylers can be found:
- In the
seriesobject, for customising primitive properties on the series level. - Inside nested series property objects, such as
marker. - Inside series and axes
labelobjects.
Each itemStyler receives a params object containing:
- Relevant details of the item, such as the
datum,seriesId, and_Keys. - The style properties currently applied to the item.
- The highlight state of the item.
- The selected and candidate state of the item.
It should return an object containing the styles to be applied to the item.
The exact details differ between the different series types and components which implement the itemStyler function.
Please use the Options Reference to learn more about Item Stylers, the inputs they receive and the attributes that can be customised.
Series Stylers Copy Link
A styler is a callback function that is called once for each series and returns style properties. These are most often used within Theme Overrides.
import { Component } from "@angular/core";
import { AgCharts } from "ag-charts-angular";
import {
AgCartesianChartOptions,
BarSeriesModule,
CategoryAxisModule,
LegendModule,
LineSeriesModule,
ModuleRegistry,
NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";
ModuleRegistry.registerModules([
BarSeriesModule,
CategoryAxisModule,
LegendModule,
LineSeriesModule,
NumberAxisModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgCharts],
template: `<ag-charts
[options]="options"
></ag-charts>
`,
})
export class AppComponent {
public options;
constructor() {
this.options = {
title: { text: "Revenue & Growth vs Benchmark" },
data: getData(),
theme: {
overrides: {
bar: {
series: {
styler: (params) => {
if (params.yKey.includes("benchmark")) {
return { fill: "lightgray" };
}
return { fill: "#5090DC" };
},
},
},
line: {
series: {
marker: { enabled: false },
strokeWidth: 4,
styler: (params) => {
if (params.yKey.includes("benchmark")) {
return { stroke: "lightgray" };
}
return { stroke: "#5090DC" };
},
},
},
},
},
series: [
{ type: "bar", xKey: "year", yKey: "revenue", yName: "Revenue" },
{
type: "bar",
xKey: "year",
yKey: "revenue_benchmark",
yName: "Revenue Benchmark",
},
{
type: "line",
xKey: "year",
yKey: "growth",
yName: "Growth",
yKeyAxis: "ySecondary",
},
{
type: "line",
xKey: "year",
yKey: "growth_benchmark",
yName: "Growth Benchmark",
yKeyAxis: "ySecondary",
},
],
axes: {
y: {
type: "number",
position: "left",
title: { text: "Revenue (M)" },
max: 500,
},
ySecondary: {
type: "number",
position: "right",
title: { text: "Growth Rate (%)" },
nice: false,
max: 0.5,
min: -0.5,
label: { formatter: ({ value }) => `${(value * 100).toFixed(0)}%` },
},
},
};
}
}
export function getData() {
return [
{
year: 2019,
revenue: 120,
revenue_benchmark: 130,
growth: 0.12,
growth_benchmark: 0.15,
},
{
year: 2020,
revenue: 135,
revenue_benchmark: 140,
growth: 0.13,
growth_benchmark: 0.14,
},
{
year: 2021,
revenue: 160,
revenue_benchmark: 170,
growth: 0.1,
growth_benchmark: 0.12,
},
{
year: 2022,
revenue: 190,
revenue_benchmark: 195,
growth: 0.2,
growth_benchmark: 0.18,
},
];
}
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
bootstrapApplication(AppComponent);
In this example:
- Any series containing 'benchmark' in its key is coloured gray, and the other series are blue.
- The legend items also reflect this styling.
{
theme: {
overrides: {
bar: {
series: {
styler: (params) => {
if (params.yKey.includes('benchmark')) {
return { fill: 'lightgray' };
}
return { fill: '#5090DC' };
},
},
},
line: {
series: {
styler: (params) => {
if (params.yKey.includes('benchmark')) {
return { stroke: 'lightgray' };
}
return { stroke: '#5090DC' };
},
},
},
},
},
} Usage Copy Link
The series level styler is called before the more specific itemStyler, with the results of the styler being passed into the itemStyler params.
Each styler receives a params object containing:
- Relevant details of the series, such as the
seriesId, and_Keys. - The style properties currently applied to the series.
- The highlight state of the series.
- The selected and candidate state of the series.
It should return an object containing the styles to be applied to the series. Styling of nested property objects other than marker must be done with an itemStyler.
The exact details differ between the different series types. Please use the Options Reference to learn more about Stylers, the inputs they receive and the attributes that can be customised.

---
product: "AG Charts"
title: "Stylers"
description: "Stylers allow customisation of the visual appearance of specific items or series based on the data or other conditions."
framework: vue
version: "14.2.0"
related:
    - title: "Cross Lines"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-cross-lines/"
    - title: "Legend"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/legend/"
    - title: "Formatters"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/formatters/"
    - title: "Series Bars"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/bars/"
    - title: "Series Fills"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/fills/"
    - title: "Series Labels"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/series-labels/"
    - title: "Series Markers"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/markers/"
    - title: "Style Segments"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/style-segments/"
    - title: "Annotations"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/annotations/"
    - title: "Background Regions"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/background-regions/"
    - title: "Colour Scale"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/colour-scale/"
    - title: "Error Bars"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/error-bars/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Stylers

Stylers allow customisation of the visual appearance of specific items or series based on the data or other conditions.

## Item Stylers

An `itemStyler` is a callback function that is called once for each item within the series, and returns style properties for that item.

To change the style of an entire series based on some condition, use a [Series Styler](https://www.ag-grid.com/charts/archive/14.2.0/vue/stylers/#series-stylers).

#### Item Styler

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { data } from "./data";

function lerpColor(t, color1, color2) {
  const tt = Math.max(0, Math.min(1.5, t)) / 1.5;
  const hexToRgb = (hex) => {
    const bigint = parseInt(hex.slice(1), 16);
    return {
      r: (bigint >> 16) & 255,
      g: (bigint >> 8) & 255,
      b: bigint & 255,
    };
  };
  const rgbToHex = (r, g, b) =>
    `#${[r, g, b].map((x) => x.toString(16).padStart(2, "0")).join("")}`;
  const c1 = hexToRgb(color1);
  const c2 = hexToRgb(color2);
  const r = Math.round(c1.r + (c2.r - c1.r) * tt);
  const g = Math.round(c1.g + (c2.g - c1.g) * tt);
  const b = Math.round(c1.b + (c2.b - c1.b) * tt);
  return rgbToHex(r, g, b);
}

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgChartOptions<DataType>>({
      data: data,
      title: {
        text: "UK Energy Sources",
      },
      subtitle: {
        text: "Source: Department for Business, Energy & Industrial Strategy",
      },
      series: [
        {
          type: "line",
          xKey: "month",
          yKey: "coal",
          yName: "Coal",
          marker: {
            itemStyler: ({ datum: { coal, nuclear }, fill, size }) => {
              return coal > nuclear
                ? { fill: "#f44", size: 15 }
                : { fill, size };
            },
          },
          label: {
            itemStyler: ({ datum: { coal, nuclear } }) => {
              if (coal > nuclear) {
                return { fontSize: 12, border: { stroke: "#f44" }, padding: 2 };
              }
              return { fontSize: 8 };
            },
          },
        },
        {
          type: "line",
          xKey: "month",
          yKey: "nuclear",
          yName: "Nuclear",
        },
        {
          type: "bar",
          xKey: "month",
          yKey: "imported",
          yName: "Imported",
          itemStyler: ({ datum, fill, highlightState }) => {
            return {
              fill:
                datum.month === "Jul"
                  ? highlightState === "highlighted-item"
                    ? "lime"
                    : "#f44"
                  : fill,
            };
          },
          label: {
            itemStyler: ({ datum: { month } }) => {
              return { color: month !== "Jul" ? "transparent" : undefined };
            },
          },
        },
      ],
      axes: {
        y: {
          type: "number",
          interval: { step: 0.2 },
          gridLine: {
            enabled: false,
          },
          max: 2,
          label: {
            format: "#{.1f}%",
            fontWeight: 600,
            itemStyler: (params) => {
              return {
                color: lerpColor(params.value, "#00b347", "#cc2900"),
              };
            },
          },
          title: {
            text: "Normalized Percentage Energy",
          },
        },
      },
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Item Styler](https://www.ag-grid.com/charts/archive/14.2.0/vue3/stylers/examples/item-styler/)

In this example:

- If the values in the 'Coal' line series are higher than the 'Nuclear' series, the markers and labels are larger and marked in red.
- The 'Imported' series bar for 'Jul' is red with a lime highlight style.
- The y-axis labels are coloured with a gradient scale.

```js
{
    series: [
        {
            type: 'line',
            //...
            marker: {
                itemStyler: ({ datum: { coal, nuclear }, fill, size }) => {
                    return coal > nuclear ? { fill: '#f44', size: 15 } : { fill, size };
                },
            },
            label: {
                itemStyler: ({ datum: { coal, nuclear } }) => {
                    if (coal > nuclear) {
                        return { fontSize: 12, border: { stroke: '#f44' }, padding: 2 };
                    }
                    return { fontSize: 8 };
                },
            },
        },
        {
            type: 'bar',
            //...
            itemStyler: ({ datum, fill, highlightState }) => {
                return {
                    fill:
                        datum.month === 'Jul'
                            ? highlightState === 'highlighted-item'
                                ? 'lime'
                                : '#f44'
                            : fill,
                };
            },
            label: {
                itemStyler: ({ datum: { month } }) => {
                    return { color: month !== 'Jul' ? 'transparent' : undefined };
                },
            },
        },
    ],
    axes: {
        x: {
            //...
            label: {
                itemStyler: (params) => {
                    return { color: lerpColor(params.value, '#00b347', '#cc2900') };
                },
            },
        },
    },
}
```

### Usage

Item Stylers can be found:

- In the `series` object, for customising primitive properties on the series level.
- Inside nested series property objects, such as `marker`.
- Inside series and axes `label` objects.

Each `itemStyler` receives a `params` object containing:

- Relevant details of the item, such as the `datum`, `seriesId`, and `_Keys`.
- The style properties currently applied to the item.
- The [highlight state](https://www.ag-grid.com/charts/archive/14.2.0/vue/series-highlighting/#stylers) of the item.
- The [selected and candidate state](https://www.ag-grid.com/charts/archive/14.2.0/vue/selection/#candidacy) of the item.

It should return an object containing the styles to be applied to the item.

The exact details differ between the different series types and components which implement the `itemStyler` function.

Please use the [Options Reference](https://www.ag-grid.com/charts/archive/14.2.0/options/) to learn more about Item Stylers, the inputs they receive and the attributes that can be customised.

## Series Stylers

A `styler` is a callback function that is called once for each series and returns style properties. These are most often used within [Theme Overrides](https://www.ag-grid.com/charts/archive/14.2.0/vue/themes/#overrides).

#### Series Styler

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      title: { text: "Revenue & Growth vs Benchmark" },
      data: getData(),
      theme: {
        overrides: {
          bar: {
            series: {
              styler: (params) => {
                if (params.yKey.includes("benchmark")) {
                  return { fill: "lightgray" };
                }
                return { fill: "#5090DC" };
              },
            },
          },
          line: {
            series: {
              marker: { enabled: false },
              strokeWidth: 4,
              styler: (params) => {
                if (params.yKey.includes("benchmark")) {
                  return { stroke: "lightgray" };
                }
                return { stroke: "#5090DC" };
              },
            },
          },
        },
      },
      series: [
        { type: "bar", xKey: "year", yKey: "revenue", yName: "Revenue" },
        {
          type: "bar",
          xKey: "year",
          yKey: "revenue_benchmark",
          yName: "Revenue Benchmark",
        },
        {
          type: "line",
          xKey: "year",
          yKey: "growth",
          yName: "Growth",
          yKeyAxis: "ySecondary",
        },
        {
          type: "line",
          xKey: "year",
          yKey: "growth_benchmark",
          yName: "Growth Benchmark",
          yKeyAxis: "ySecondary",
        },
      ],
      axes: {
        y: {
          type: "number",
          position: "left",
          title: { text: "Revenue (M)" },
          max: 500,
        },
        ySecondary: {
          type: "number",
          position: "right",
          title: { text: "Growth Rate (%)" },
          nice: false,
          max: 0.5,
          min: -0.5,
          label: { formatter: ({ value }) => `${(value * 100).toFixed(0)}%` },
        },
      },
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Series Styler](https://www.ag-grid.com/charts/archive/14.2.0/vue3/stylers/examples/series-styler/)

In this example:

- Any series containing 'benchmark' in its key is coloured gray, and the other series are blue.
- The legend items also reflect this styling.

```js
{
    theme: {
        overrides: {
            bar: {
                series: {
                    styler: (params) => {
                        if (params.yKey.includes('benchmark')) {
                            return { fill: 'lightgray' };
                        }
                        return { fill: '#5090DC' };
                    },
                },
            },
            line: {
                series: {
                    styler: (params) => {
                        if (params.yKey.includes('benchmark')) {
                            return { stroke: 'lightgray' };
                        }
                        return { stroke: '#5090DC' };
                    },
                },
            },
        },
    },
}
```

### Usage

The series level `styler` is called before the more specific `itemStyler`, with the results of the `styler` being passed into the `itemStyler` params.

Each `styler` receives a `params` object containing:

- Relevant details of the series, such as the `seriesId`, and `_Keys`.
- The style properties currently applied to the series.
- The [highlight state](https://www.ag-grid.com/charts/archive/14.2.0/vue/series-highlighting/#stylers) of the series.
- The [selected and candidate state](https://www.ag-grid.com/charts/archive/14.2.0/vue/selection/#candidacy) of the series.

It should return an object containing the styles to be applied to the series. Styling of nested property objects other than `marker` must be done with an `itemStyler`.

The exact details differ between the different series types. Please use the [Options Reference](https://www.ag-grid.com/charts/archive/14.2.0/options/) to learn more about Stylers, the inputs they receive and the attributes that can be customised.


---
product: "AG Charts"
title: "Stylers"
description: "Stylers allow customisation of the visual appearance of specific items or series based on the data or other conditions."
framework: react
version: "14.2.0"
related:
    - title: "Cross Lines"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/axes-cross-lines/"
    - title: "Legend"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/legend/"
    - title: "Formatters"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/formatters/"
    - title: "Series Bars"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/bars/"
    - title: "Series Fills"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/fills/"
    - title: "Series Labels"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/series-labels/"
    - title: "Series Markers"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/markers/"
    - title: "Style Segments"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/style-segments/"
    - title: "Annotations"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/annotations/"
    - title: "Background Regions"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/background-regions/"
    - title: "Colour Scale"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/colour-scale/"
    - title: "Error Bars"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/error-bars/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Stylers

Stylers allow customisation of the visual appearance of specific items or series based on the data or other conditions.

## Item Stylers

An `itemStyler` is a callback function that is called once for each item within the series, and returns style properties for that item.

To change the style of an entire series based on some condition, use a [Series Styler](https://www.ag-grid.com/charts/archive/14.2.0/react/stylers/#series-stylers).

#### Item Styler

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgChartOptions,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { DataType, data } from "./data";

function lerpColor(t: number, color1: string, color2: string): string {
  const tt = Math.max(0, Math.min(1.5, t)) / 1.5;
  const hexToRgb = (hex: string) => {
    const bigint = parseInt(hex.slice(1), 16);
    return {
      r: (bigint >> 16) & 255,
      g: (bigint >> 8) & 255,
      b: bigint & 255,
    };
  };
  const rgbToHex = (r: number, g: number, b: number) =>
    `#${[r, g, b].map((x) => x.toString(16).padStart(2, "0")).join("")}`;
  const c1 = hexToRgb(color1);
  const c2 = hexToRgb(color2);
  const r = Math.round(c1.r + (c2.r - c1.r) * tt);
  const g = Math.round(c1.g + (c2.g - c1.g) * tt);
  const b = Math.round(c1.b + (c2.b - c1.b) * tt);
  return rgbToHex(r, g, b);
}
ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgChartOptions<DataType>>({
    data: data,
    title: {
      text: "UK Energy Sources",
    },
    subtitle: {
      text: "Source: Department for Business, Energy & Industrial Strategy",
    },
    series: [
      {
        type: "line",
        xKey: "month",
        yKey: "coal",
        yName: "Coal",
        marker: {
          itemStyler: ({ datum: { coal, nuclear }, fill, size }) => {
            return coal > nuclear ? { fill: "#f44", size: 15 } : { fill, size };
          },
        },
        label: {
          itemStyler: ({ datum: { coal, nuclear } }) => {
            if (coal > nuclear) {
              return { fontSize: 12, border: { stroke: "#f44" }, padding: 2 };
            }
            return { fontSize: 8 };
          },
        },
      },
      {
        type: "line",
        xKey: "month",
        yKey: "nuclear",
        yName: "Nuclear",
      },
      {
        type: "bar",
        xKey: "month",
        yKey: "imported",
        yName: "Imported",
        itemStyler: ({ datum, fill, highlightState }) => {
          return {
            fill:
              datum.month === "Jul"
                ? highlightState === "highlighted-item"
                  ? "lime"
                  : "#f44"
                : fill,
          };
        },
        label: {
          itemStyler: ({ datum: { month } }) => {
            return { color: month !== "Jul" ? "transparent" : undefined };
          },
        },
      },
    ],
    axes: {
      y: {
        type: "number",
        interval: { step: 0.2 },
        gridLine: {
          enabled: false,
        },
        max: 2,
        label: {
          format: "#{.1f}%",
          fontWeight: 600,
          itemStyler: (params) => {
            return {
              color: lerpColor(params.value, "#00b347", "#cc2900"),
            };
          },
        },
        title: {
          text: "Normalized Percentage Energy",
        },
      },
    },
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Item Styler](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/stylers/examples/item-styler/)

In this example:

- If the values in the 'Coal' line series are higher than the 'Nuclear' series, the markers and labels are larger and marked in red.
- The 'Imported' series bar for 'Jul' is red with a lime highlight style.
- The y-axis labels are coloured with a gradient scale.

```js
{
    series: [
        {
            type: 'line',
            //...
            marker: {
                itemStyler: ({ datum: { coal, nuclear }, fill, size }) => {
                    return coal > nuclear ? { fill: '#f44', size: 15 } : { fill, size };
                },
            },
            label: {
                itemStyler: ({ datum: { coal, nuclear } }) => {
                    if (coal > nuclear) {
                        return { fontSize: 12, border: { stroke: '#f44' }, padding: 2 };
                    }
                    return { fontSize: 8 };
                },
            },
        },
        {
            type: 'bar',
            //...
            itemStyler: ({ datum, fill, highlightState }) => {
                return {
                    fill:
                        datum.month === 'Jul'
                            ? highlightState === 'highlighted-item'
                                ? 'lime'
                                : '#f44'
                            : fill,
                };
            },
            label: {
                itemStyler: ({ datum: { month } }) => {
                    return { color: month !== 'Jul' ? 'transparent' : undefined };
                },
            },
        },
    ],
    axes: {
        x: {
            //...
            label: {
                itemStyler: (params) => {
                    return { color: lerpColor(params.value, '#00b347', '#cc2900') };
                },
            },
        },
    },
}
```

### Usage

Item Stylers can be found:

- In the `series` object, for customising primitive properties on the series level.
- Inside nested series property objects, such as `marker`.
- Inside series and axes `label` objects.

Each `itemStyler` receives a `params` object containing:

- Relevant details of the item, such as the `datum`, `seriesId`, and `_Keys`.
- The style properties currently applied to the item.
- The [highlight state](https://www.ag-grid.com/charts/archive/14.2.0/react/series-highlighting/#stylers) of the item.
- The [selected and candidate state](https://www.ag-grid.com/charts/archive/14.2.0/react/selection/#candidacy) of the item.

It should return an object containing the styles to be applied to the item.

The exact details differ between the different series types and components which implement the `itemStyler` function.

Please use the [Options Reference](https://www.ag-grid.com/charts/archive/14.2.0/options/) to learn more about Item Stylers, the inputs they receive and the attributes that can be customised.

## Series Stylers

A `styler` is a callback function that is called once for each series and returns style properties. These are most often used within [Theme Overrides](https://www.ag-grid.com/charts/archive/14.2.0/react/themes/#overrides).

#### Series Styler

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  LineSeriesModule,
  NumberAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    title: { text: "Revenue & Growth vs Benchmark" },
    data: getData(),
    theme: {
      overrides: {
        bar: {
          series: {
            styler: (params) => {
              if (params.yKey.includes("benchmark")) {
                return { fill: "lightgray" };
              }
              return { fill: "#5090DC" };
            },
          },
        },
        line: {
          series: {
            marker: { enabled: false },
            strokeWidth: 4,
            styler: (params) => {
              if (params.yKey.includes("benchmark")) {
                return { stroke: "lightgray" };
              }
              return { stroke: "#5090DC" };
            },
          },
        },
      },
    },
    series: [
      { type: "bar", xKey: "year", yKey: "revenue", yName: "Revenue" },
      {
        type: "bar",
        xKey: "year",
        yKey: "revenue_benchmark",
        yName: "Revenue Benchmark",
      },
      {
        type: "line",
        xKey: "year",
        yKey: "growth",
        yName: "Growth",
        yKeyAxis: "ySecondary",
      },
      {
        type: "line",
        xKey: "year",
        yKey: "growth_benchmark",
        yName: "Growth Benchmark",
        yKeyAxis: "ySecondary",
      },
    ],
    axes: {
      y: {
        type: "number",
        position: "left",
        title: { text: "Revenue (M)" },
        max: 500,
      },
      ySecondary: {
        type: "number",
        position: "right",
        title: { text: "Growth Rate (%)" },
        nice: false,
        max: 0.5,
        min: -0.5,
        label: { formatter: ({ value }) => `${(value * 100).toFixed(0)}%` },
      },
    },
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Series Styler](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/stylers/examples/series-styler/)

In this example:

- Any series containing 'benchmark' in its key is coloured gray, and the other series are blue.
- The legend items also reflect this styling.

```js
{
    theme: {
        overrides: {
            bar: {
                series: {
                    styler: (params) => {
                        if (params.yKey.includes('benchmark')) {
                            return { fill: 'lightgray' };
                        }
                        return { fill: '#5090DC' };
                    },
                },
            },
            line: {
                series: {
                    styler: (params) => {
                        if (params.yKey.includes('benchmark')) {
                            return { stroke: 'lightgray' };
                        }
                        return { stroke: '#5090DC' };
                    },
                },
            },
        },
    },
}
```

### Usage

The series level `styler` is called before the more specific `itemStyler`, with the results of the `styler` being passed into the `itemStyler` params.

Each `styler` receives a `params` object containing:

- Relevant details of the series, such as the `seriesId`, and `_Keys`.
- The style properties currently applied to the series.
- The [highlight state](https://www.ag-grid.com/charts/archive/14.2.0/react/series-highlighting/#stylers) of the series.
- The [selected and candidate state](https://www.ag-grid.com/charts/archive/14.2.0/react/selection/#candidacy) of the series.

It should return an object containing the styles to be applied to the series. Styling of nested property objects other than `marker` must be done with an `itemStyler`.

The exact details differ between the different series types. Please use the [Options Reference](https://www.ag-grid.com/charts/archive/14.2.0/options/) to learn more about Stylers, the inputs they receive and the attributes that can be customised.
